_ace.exportUnityJavascriptFileFormat = {};

_ace.exportUnityJavascriptFileFormat.NavigationButtonsHtml = function(){

	var html = '';
	html += '<ul class="Menu">';
	html += '<li class="MenuItem"><a onclick="_ace.exportUnityJavascriptFileFormat.exportButton()" class="Button">Export Unity 3d Javascript Format</a></li>';
	html += '</ul>';
	return html;
	
}

_ace.App.create.topNavigationHtmlFunctionArray.push(_ace.exportUnityJavascriptFileFormat.NavigationButtonsHtml);

_ace.exportUnityJavascriptFileFormat.exportButton = function(){

	var i = 0; 
	var ii = 0;
	var iii = 0;
	var j = 0;
	var jj = 0;
	var tileSetCount;
	var levelCount;
	var layerCount;
	var tileCount;
	var arrayOfTileSetIndexes;
	var TileSetZero;
	
	if(_ace.currentProject.STRING_application!=undefined){

		var string = "";
		string += '#pragma strict<br/>';
		string += '<br/>';
		string += '/* Made With A Tile Map Editor 2 */<br/>';
		string += '/* Ola Persson - 2014 - www.olapersson.com */<br/>';
		string += '<br/>';
		string += '/* --- Classes ---*/<br/>';
		string += '<br/>';
		string += 'class GameFile {<br/>';
			string += 'var GameName : String;<br/>';
			string += 'var OriginalScreenSize : intVector2;<br/>';
			string += 'var TileSets : TileSet[];<br/>';
			string += 'var Levels : Level[];<br/>';
		string += '}<br/>';
		string += '<br/>';
		string += 'class intVector2 {<br/>';
			string += 'var TheX : int;<br/>';
			string += 'var TheY : int;<br/>';
		string += '}<br/>';
		string += '<br/>';
		string += 'class TileSet {<br/>';
			string += 'var TileSetName : String;<br/>';
			string += 'var TileSetMaterial : Material;<br/>';
			string += 'var PixelStartPosition : intVector2;<br/>';
			string += 'var TilePixelSize : intVector2;<br/>';
			string += 'var PixelSpaceBetweenTiles : intVector2;<br/>';
			string += 'var TileCount : intVector2;<br/>';
			string += 'var AirTileIndex : int;<br/>';
		string += '}<br/>';
		string += '<br/>';
		string += 'class Level {<br/>';
			string += 'var LevelName : String;<br/>';
			string += 'var TextString : String;<br/>';
			string += 'var LevelPixelSize : intVector2;<br/>';
			string += 'var TileZoomFactor : int;<br/>';
			string += 'var ArrayOfLayers : TileMapLayer[];<br/>';
		string += '}<br/>';
		string += '<br/>';
		string += 'class TileMapLayer {<br/>';
			string += 'var LayerName : String;<br/>';
			string += 'var ParallaxSpeed : Vector2;<br/>';
			string += 'var MapTileSize : intVector2;<br/>';
			string += 'var TileGridPixelSize : intVector2;<br/>';
			string += 'var Map : Tile[];<br/>';
		string += '}<br/>';
		string += '<br/>';
		string += 'class Tile {<br/>';
			string += 'var TileIndex : int;<br/>';
			string += 'var TileSetIndex : int;<br/>';
			string += 'var TextString : String;<br/>';
			string += 'var Tag : String;<br/>';
		string += '}<br/>';
		string += '<br/>';
		string += '/*--- Variables ---*/<br/>';
		string += '<br/>';
		string += 'static var GameFile : GameFile;<br/>';
		
		tileSetCount = _ace.currentProject.tileSets.length;
		
		for(i=0; i<tileSetCount; i++){
			string += 'var TileSetMaterial'+i+' : Material;<br/>';
		}
		
		string += '<br/>';
		string += '/*--- Functions ---*/<br/>';
		string += '<br/>';
		string += 'function InitiateLevel(){<br/>';
		
			string += 'GameFile = new GameFile();<br/>';

			string += 'GameFile.GameName = "'+_ace.currentProject.STRING_name+'";<br/>';
			string += 'GameFile.OriginalScreenSize = new intVector2();<br/>';
			string += 'GameFile.OriginalScreenSize.TheX = '+_ace.currentProject.parallaxMode.INTEGER_screenSizeWidth+';<br/>';
			string += 'GameFile.OriginalScreenSize.TheY = '+_ace.currentProject.parallaxMode.INTEGER_screenSizeHeight+';<br/>';
			string += '<br/>';
			
			
			
			string += '/*--- Tile Sets ---*/<br/>';
			string += '<br/>';
			string += 'GameFile.TileSets = new TileSet['+tileSetCount+'];<br/>';
			
			for(i = 0; i < tileSetCount; i++){
				string += '<br/>';
				string += 'GameFile.TileSets['+i+'] = new TileSet();<br/>';
				string += 'GameFile.TileSets['+i+'].TileSetName = "'+_ace.currentProject.tileSets[i].STRING_tileSetName+'";<br/>';
				string += 'GameFile.TileSets['+i+'].TileSetMaterial = TileSetMaterial'+i+';<br/>';
				string += 'GameFile.TileSets['+i+'].PixelStartPosition = new intVector2();<br/>';
				string += 'GameFile.TileSets['+i+'].PixelStartPosition.TheX = '+_ace.currentProject.tileSets[i].pixelStartPosition.INTEGER_x+';<br/>';
				string += 'GameFile.TileSets['+i+'].PixelStartPosition.TheY = '+_ace.currentProject.tileSets[i].pixelStartPosition.INTEGER_y+';<br/>';
				string += 'GameFile.TileSets['+i+'].TilePixelSize = new intVector2();<br/>';
				string += 'GameFile.TileSets['+i+'].TilePixelSize.TheX = '+_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_width+';<br/>';
				string += 'GameFile.TileSets['+i+'].TilePixelSize.TheY = '+_ace.currentProject.tileSets[i].tilePixelSize.INTEGER_height+';<br/>';
				string += 'GameFile.TileSets['+i+'].PixelSpaceBetweenTiles = new intVector2();<br/>';
				string += 'GameFile.TileSets['+i+'].PixelSpaceBetweenTiles.TheX = '+_ace.currentProject.tileSets[i].pixelSpaceBetweenTiles.INTEGER_x+';<br/>';
				string += 'GameFile.TileSets['+i+'].PixelSpaceBetweenTiles.TheY = '+_ace.currentProject.tileSets[i].pixelSpaceBetweenTiles.INTEGER_y+';<br/>';
				string += 'GameFile.TileSets['+i+'].TileCount = new intVector2();<br/>';
				string += 'GameFile.TileSets['+i+'].TileCount.TheX = '+_ace.currentProject.tileSets[i].tileCount.INTEGER_tilesWide+';<br/>';
				string += 'GameFile.TileSets['+i+'].TileCount.TheY = '+_ace.currentProject.tileSets[i].tileCount.INTEGER_tilesHigh+';<br/>';
				string += 'GameFile.TileSets['+i+'].AirTileIndex = '+_ace.currentProject.tileSets[i].tileSetEditorSettings.INTEGER_airTile+';<br/>';
				string += '<br/>';
			}
			
			levelCount = _ace.currentProject.arrayOfLevels.length;
			
			string += '/*--- Levels ---*/<br/>';
			string += '<br/>';
			string += 'GameFile.Levels = new Level['+levelCount+'];<br/>';
			string += '<br/>';
			
			for(i = 0; i < levelCount; i++){
			
				layerCount = _ace.currentProject.arrayOfLevels[i].arrayOfLayers.length;
				
			
				string += '/*--- Level '+i+' ---*/<br/>';
				string += '<br/>';
				string += 'GameFile.Levels['+i+'] = new Level();<br/>';
				string += 'GameFile.Levels['+i+'].LevelName = "'+_ace.currentProject.arrayOfLevels[i].STRING_levelName+'";<br/>';
				string += 'GameFile.Levels['+i+'].TextString = "'+_ace.currentProject.arrayOfLevels[i].STRING_textString+'";<br/>';
				string += 'GameFile.Levels['+i+'].LevelPixelSize = new intVector2();<br/>';
				string += 'GameFile.Levels['+i+'].LevelPixelSize.TheX = '+_ace.currentProject.arrayOfLevels[i].levelPixelSize.INTEGER_width+';<br/>';
				string += 'GameFile.Levels['+i+'].LevelPixelSize.TheY = '+_ace.currentProject.arrayOfLevels[i].levelPixelSize.INTEGER_height+';<br/>';
				string += 'GameFile.Levels['+i+'].TileZoomFactor = '+_ace.currentProject.arrayOfLevels[i].FLOAT_tileZoomFactor+';<br/>';
			
				string += '<br/>';
				string += 'GameFile.Levels['+i+'].ArrayOfLayers = new TileMapLayer['+layerCount+'];<br/>';
				string += '<br/>';
			
				for(ii=0; ii<layerCount; ii++){
					
					tileCount = _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map.length;
					arrayOfTileSetIndexes = [];
				
					for(j = 0; j<_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].ARRAY_useTileSetsWithIdentifyer.length; j++){
						for(jj = 0; jj<_ace.currentProject.tileSets.length; jj++){
							if(_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].ARRAY_useTileSetsWithIdentifyer[j] == _ace.currentProject.tileSets[jj].STRING_tileSetIdentifyer){
								arrayOfTileSetIndexes.push(jj);
								break;
							}
						}
					}
					
					TileSetZero = _ace.currentProject.tileSets[arrayOfTileSetIndexes[0]];
									
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'] = new TileMapLayer();<br/>';
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].LayerName = "'+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_layerName+'";<br/>';
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].ParallaxSpeed = Vector2('+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].parallaxSpeed.FLOAT_x+', '+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].parallaxSpeed.FLOAT_y+');<br/>';
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].MapTileSize = new intVector2();<br/>';
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].MapTileSize.TheX = '+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].mapSize.INTEGER_width+';<br/>';
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].MapTileSize.TheY = '+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].mapSize.INTEGER_height+';<br/>';
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].TileGridPixelSize = new intVector2();<br/>';
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].TileGridPixelSize.TheX = '+TileSetZero.tilePixelSize.INTEGER_width+';<br/>';
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].TileGridPixelSize.TheY = '+TileSetZero.tilePixelSize.INTEGER_height+';<br/>';
					string += '<br/>';
					
					string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].Map = new Tile['+tileCount+'];<br/>';
					
					for(iii=0; iii<tileCount; iii++){
						string += '<br/>';
						string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].Map['+iii+'] = new Tile();<br/>';
						string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].Map['+iii+'].TileIndex = '+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map[iii].INTEGER_tileIndex+';<br/>';
						string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].Map['+iii+'].TileSetIndex = '+arrayOfTileSetIndexes[_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map[iii].INTEGER_tileSetIndex]+';<br/>';
						string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].Map['+iii+'].TextString = "'+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map[iii].STRING_textString+'";<br/>';
						string += 'GameFile.Levels['+i+'].ArrayOfLayers['+ii+'].Map['+iii+'].Tag = "'+_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].map[iii].STRING_tag+'";<br/>';
					}
				}
				string += '<br/>';
			}
			
			
		string += '}<br/>';
		string += '<br/>';
		string += 'function Awake(){<br/>';
			string += 'InitiateLevel();<br/>';
		string += '}<br/>';
		
		var html = '<span class="PromptBoxTitle">Copy This Level Object (String)</span><div class="SaveLevelString" id="SaveLevelStringId">' + string + "</div>";
		_ace.prompt({}, "", html);

		_ace.GeneralFunctions.SelectTextInsideId("SaveLevelStringId");

	} else {
		_ace.prompt({}, "","No Project File Found. Create One By Clicking \"New Project\"");
	}
}







_ace.exportUnityJavascriptFileFormat.createStandalone = function(){
	
	var theProject = jQuery.extend(true, {}, _ace.currentProject);
	theProject.styleSheets = null;
	theProject.resources.fonts = jQuery.extend(true, [], _ace.fontManagement.base64Fonts);
	theProject.animationStyles = jQuery.extend(true, [], _ace.animationManagement.animationStyles);

	theProject = _ace.exportUnityJavascriptFileFormat.escapeNewLineInTextStrings(theProject);
	theProject = _ace.exportUnityJavascriptFileFormat.removeFontsNotUsed(theProject);
	theProject = _ace.exportUnityJavascriptFileFormat.removeImagesNotUsed(theProject);
	theProject = _ace.exportUnityJavascriptFileFormat.removeAnimationStylesNotUsed(theProject);
	
	var string;
	var singleOutputFormatProject;
	var theOutputObject;
	var theFileName;
	// console.log(theProject);
	for(var i = 0; i < theProject.outputFormatArray.length; i++){
		singleOutputFormatProject = jQuery.extend(true, {}, theProject);
		theOutputObject = singleOutputFormatProject.outputFormatArray.splice(i,1); 
		singleOutputFormatProject.outputFormatArray = theOutputObject;
		string = '(function () {';
		
		string += _ace.exportUnityJavascriptFileFormat.standAlonePlayerScript();
		string += "_ace.currentProject="+_ace.GeneralFunctions.ConvertToString(singleOutputFormatProject);
		string += '}());';
		theFileName = singleOutputFormatProject.name + "_" + theOutputObject[0].name + "_" + theOutputObject[0].size.x +"x"+theOutputObject[0].size.y;
		theFileName = _ace.GeneralFunctions.convertToFilename(theFileName);
		theFileName += ".js";
		_ace.exportUnityJavascriptFileFormat.createDownloadableJsFile(string, theFileName, theFileName);
	}

	
}


_ace.exportUnityJavascriptFileFormat.escapeNewLineInTextStrings = function(theProject){
	for(var i = 0; i < theProject.arrayOfLevels.length; i++){
		for(var ii = 0; ii < theProject.arrayOfLevels[i].arrayOfLayers.length; ii++){
			if(theProject.arrayOfLevels[i].arrayOfLayers[ii].type == "text"){
				theProject.arrayOfLevels[i].arrayOfLayers[ii].string = theProject.arrayOfLevels[i].arrayOfLayers[ii].string.replace(/\n/g, "\\n");
			}
		}
	}
	return theProject;
}



_ace.exportUnityJavascriptFileFormat.createDownloadableJsFile = function(theString, fileName, downloadTitle){

	// theString = theString.replace(/_ace/g, "_"+Math.random().toString(36).substr(2, 9));
	
	// var textToWrite = document.getElementById("inputTextToSave").value;
	// var textFileAsBlob = new Blob([theString], {type:'text/plain'});
	var textFileAsBlob = new Blob([theString], {type:'text/javascript'});
	var fileNameToSaveAs = fileName; // document.getElementById("inputFileNameToSaveAs").value;

	var downloadLink = document.createElement("a");
	downloadLink.download = fileNameToSaveAs;
	downloadLink.innerHTML = downloadTitle;
	downloadLink.className = "DownloadLink";
	
	
	
	if (window.webkitURL != null)
	{
		// Chrome allows the link to be clicked
		// without actually adding it to the DOM.
		downloadLink.href = window.webkitURL.createObjectURL(textFileAsBlob);
	}
	else
	{
		// Firefox requires the link to be added to the DOM
		// before it can be clicked.
		downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
		// downloadLink.onclick = destroyClickedElement;
		// downloadLink.style.display = "none";
		// document.body.appendChild(downloadLink);
	}
	
	$("#DownloadFiles").append(downloadLink);

	// downloadLink.click();
}


