/* 
	-----------------------------------------------------------------

	A Tile Map Editor 2
	By Ola Persson
	ola@kongotec.com
	www.kongotec.com
	
	Level Organizer Description: 
	Create And Sort Levels And Layers
	
	-----------------------------------------------------------------
*/

_ace.levelOrganizer = {};
_ace.levelOrganizer.currentlySelected = [];

_ace.levelOrganizer.LevelOrganizerMiddleHtml = function(){
	var html = '';
	html += '<div id="LevelOrganizer" class="LevelOrganizer">';
	html += '</div>';
	return html;
}
_ace.App.create.leftSideMiddleNavigationHtmlFunctionArray.push(_ace.levelOrganizer.LevelOrganizerMiddleHtml);

_ace.levelOrganizer.ProjectGlobalSettingsButtonHtml = function(){
	var html = '';
	html += '<ul class="GlobalSettingsContiner">';
	html += '<li class="SettingContiner">';
	html += '<span class="SettingsButton" id="ProjectSettings" onclick="_ace.levelOrganizer.selectProjectSettings()" >Project settings</span>';
	html += '</li>';
	html += '</ul>';
	return html;
}
_ace.App.create.leftSideTopNavigationHtmlFunctionArray.push(_ace.levelOrganizer.ProjectGlobalSettingsButtonHtml);

_ace.levelOrganizer.selectProjectSettings = function(){
	$(".SettingsButton").removeClass( "SelectedSetting" );
	$(".Layer").removeClass( "SelectedLayer" );
	$(".Level").removeClass( "SelectedLevel" );
	$(".SettingsButton").addClass( "SelectedSetting" );
	_ace.levelOrganizer.currentlySelected = "ProjectSettings";
	_ace.preferenceInspector.drawCurrentObject();
	_ace.mainView.drawOutputCanvases();
}

_ace.levelOrganizer.LevelOrganizerBottomHtml = function(){
	var html = '';
	
	html += '<ul class="Menu SmallMenu">';
	html += '<li class="MenuLabel">Level</li>';
	html += '<li class="MenuItem">';
	html += '<a class="Button AddNewLevel" onclick="_ace.levelOrganizer.addLevelButton()" title="Add New Level">New Level</a>';
	html += '</ul>';

	html += '<ul class="Menu SmallMenu">';
	html += '<li class="MenuLabel">Layers</li>';
	html += '<li class="MenuItem">';
	html += '<a class="Button AddTextLayer" onclick="_ace.levelOrganizer.addTileMapLayerButton()" title="Add Tile Map Layer">New Tile Map Layer</a>';
	html += '</li>';
	html += '</ul>';
	
	html += '<ul class="Menu SmallMenu">';
	html += '<li class="MenuLabel">Selected</li>';
	html += '<li class="MenuItem">';
	html += '<a class="Button DuplicateSelected" onclick="_ace.levelOrganizer.duplicateSelected()" title="Duplicate Selected">Duplicate</a>';
	html += '</li>';
	html += '<li class="MenuItem">';
	html += '<a class="Button DeleteSelected" onclick="_ace.levelOrganizer.deleteSelected()" title="Delete Selected">Delete</a>';
	html += '</li>';
	html += '</ul>';
	
	return html;
}
_ace.App.create.leftSideBottomNavigationHtmlFunctionArray.push(_ace.levelOrganizer.LevelOrganizerBottomHtml);

_ace.levelOrganizer.Draw = function(){

	$(".SettingsButton").removeClass( "SelectedSetting" );

	var html = "";
	var levelName = "";
	var layerName = "";

	html += '<ul id="LevelsContiner" class="LevelsContiner">';
	for (var i = 0; i < _ace.currentProject.arrayOfLevels.length; i++){
		var staticLevelCss = _ace.currentProject.arrayOfLevels[i].BOOLEAN_staticLevel == true ? ' StaticLevel' : '';
		levelName = _ace.currentProject.arrayOfLevels[i].STRING_levelName;
		if(levelName){
			if(levelName.length > 20) layerName = _ace.GeneralFunctions.ShortenString(layerName, 17);
			levelName = i + " - " + levelName;
		} else {
			levelName = i;
		}
		html += '<li class="Level'+staticLevelCss+'"><span class="LevelHeader">'+levelName+'</span><ul class="LayerList" id="LevelLayerList'+i+'">';
		for(var ii = 0; ii < _ace.currentProject.arrayOfLevels[i].arrayOfLayers.length; ii++){
			layerName = _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_layerName.length == 0 ? _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_string : _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_layerName;
			if(layerName){
				if(layerName.length > 20) layerName = _ace.GeneralFunctions.ShortenString(layerName, 17);
			}else {
				layerName = _ace.GeneralFunctions.consvertToDisplayText(_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_objectType);
			}
			layerVisibleClass = _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].editorSettings.BOOLEAN_visible ? "Checked" : "";
			layerSoloVisibilityClass = _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].editorSettings.BOOLEAN_soloVisibility ? "Checked" : "";
		
			html += '<li class="Layer"><span class="ToggleVisibilityButton '+layerVisibleClass+'"></span><span class="ToggleSoloVisibilityButton '+layerSoloVisibilityClass+'"></span>'+layerName+'</li>';
		}
		html += '</ul></li>';
	}
	html += '</ul>';
	$("#LevelOrganizer").html(html);
	_ace.levelOrganizer.bindClickOnLayerVisibilityButtons();
	// _ace.levelOrganizer.makeLayersFoldable();
	_ace.levelOrganizer.makeLevelsSortable();
	_ace.levelOrganizer.makeLevelsClickable();
	_ace.levelOrganizer.makeLayersSortable();
	_ace.levelOrganizer.makeLayersClickable();

}

_ace.levelOrganizer.update = function(){
	$('.Level').removeClass('StaticLevel');
	var layerName;
	var levelElement;
	var layerElements;
	var layerElement;
	var levelName;
	var layerVisibleClass;
	var layerSoloVisibilityClass;
	for (var i = 0; i < _ace.currentProject.arrayOfLevels.length; i++){
		levelElement = $("#LevelsContiner").children().get(i);
		if(_ace.currentProject.arrayOfLevels[i].BOOLEAN_staticLevel == true){
			$(levelElement).addClass('StaticLevel');
		}
		levelName = _ace.currentProject.arrayOfLevels[i].STRING_levelName;
		if(levelName){
			if(levelName.length > 20) layerName = _ace.GeneralFunctions.ShortenString(layerName, 17);
			levelName = i + " - " + levelName;
		} else {
			levelName = i;
		}
		$(levelElement).find(".LevelHeader").html(levelName);
		layerElements = $(levelElement).find(".LayerList").children();
		for(var ii = 0; ii < _ace.currentProject.arrayOfLevels[i].arrayOfLayers.length; ii++){
			layerName = _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_layerName.length == 0 ? _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_string : _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_layerName;
			if(layerName){
				if(layerName.length > 20) layerName = _ace.GeneralFunctions.ShortenString(layerName, 17);
			} else {
				layerName = _ace.GeneralFunctions.consvertToDisplayText(_ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].STRING_objectType);
			}
			layerVisibleClass = _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].editorSettings.BOOLEAN_visible ? "Checked" : "";
			layerSoloVisibilityClass = _ace.currentProject.arrayOfLevels[i].arrayOfLayers[ii].editorSettings.BOOLEAN_soloVisibility ? "Checked" : "";
		
			layerElement = $(layerElements).get(ii);
			$(layerElement).html('<span class="ToggleVisibilityButton '+layerVisibleClass+'"></span><span class="ToggleSoloVisibilityButton '+layerSoloVisibilityClass+'"></span>'+layerName);
		}
	}
	_ace.levelOrganizer.bindClickOnLayerVisibilityButtons();
}

_ace.levelOrganizer.bindClickOnLayerVisibilityButtons = function(){
	$( ".ToggleVisibilityButton" ).click(function(event) {
		event.stopPropagation();
		_ace.levelOrganizer.toggleLayerVisibility(this);
	});
	$( ".ToggleSoloVisibilityButton" ).click(function(event) {
		event.stopPropagation();
		_ace.levelOrganizer.toggleLayerSoloVisibility(this);
	});
}

_ace.levelOrganizer.toggleLayerVisibility = function(buttonElement){
	var levelIndex = $(buttonElement).parent().parent().parent().index();
	var layerIndex = $(buttonElement).parent().index();
	var originalValue = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex].editorSettings.BOOLEAN_visible;
	_ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex].editorSettings.BOOLEAN_visible = originalValue ? false : true;
	_ace.preferenceInspector.drawCurrentObject();
	_ace.mainView.drawOutputCanvases();
	_ace.levelOrganizer.update();
}

_ace.levelOrganizer.toggleLayerSoloVisibility = function(buttonElement){
	var levelIndex = $(buttonElement).parent().parent().parent().index();
	var layerIndex = $(buttonElement).parent().index();
	var originalValue = _ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex].editorSettings.BOOLEAN_soloVisibility;
	_ace.currentProject.arrayOfLevels[levelIndex].arrayOfLayers[layerIndex].editorSettings.BOOLEAN_soloVisibility = originalValue ? false : true;
	_ace.preferenceInspector.drawCurrentObject();
	_ace.mainView.drawOutputCanvases();
	_ace.levelOrganizer.update();
}

_ace.levelOrganizer.addTileMapLayerButton = function(){
	if(_ace.levelOrganizer.currentlySelected.length<1){
		_ace.prompt({}, "","Can't add layer. No level selected.");	
		return;
	}
	var tileMapNames = [];
	for(var i = 0; i < _ace.currentProject.tileSets.length; i++){
		tileMapNames.push(_ace.currentProject.tileSets[i].STRING_tileSetName);
	}
	
	_ace.prompt({
		"Layer Name (String)" : "A Tile Map Layer",
		"Tile Map (Index)" : tileMapNames
 	}, 
	"_ace.levelOrganizer.addTileMapLayer()",
	"Add New Tile Map Layer To Selected Level");
}

_ace.levelOrganizer.addTileMapLayer = function(){
	var promptResults = _ace.getPromptResults();
	var selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
	var levelObject = _ace.currentProject.arrayOfLevels[selectedLevelIndex];
	var selectedLayerIndex = _ace.levelOrganizer.currentlySelected[1];
	var useTileSetsWithIdentifyer = [_ace.currentProject.tileSets[promptResults.TileMap].STRING_tileSetIdentifyer+""];
	
	var parallaxSpeed = {
		FLOAT_x: 1.0,
		FLOAT_y: 1.0
	};
	
	var i;
	var theTileSet;
	for(i = 0; i < _ace.currentProject.tileSets.length; i++){
		if(useTileSetsWithIdentifyer[0] == _ace.currentProject.tileSets[i].STRING_tileSetIdentifyer){
			theTileSet = _ace.currentProject.tileSets[i];
		}
	}

	var recommendedWidth = (levelObject.levelPixelSize.INTEGER_width * parallaxSpeed.FLOAT_x);
	recommendedWidth += -_ace.currentProject.parallaxMode.INTEGER_screenSizeWidth * (parallaxSpeed.FLOAT_x - 1);
	recommendedWidth /= (theTileSet.tilePixelSize.INTEGER_width * levelObject.FLOAT_tileZoomFactor);
	recommendedWidth = Math.ceil(recommendedWidth);
		
	var recommendedHeight = (levelObject.levelPixelSize.INTEGER_height * parallaxSpeed.FLOAT_y); 
	recommendedHeight += -_ace.currentProject.parallaxMode.INTEGER_screenSizeHeight * (parallaxSpeed.FLOAT_y - 1);
	recommendedHeight /= (theTileSet.tilePixelSize.INTEGER_height * levelObject.FLOAT_tileZoomFactor);
	recommendedHeight = Math.ceil(recommendedHeight);
	
	var objectToAdd = {
        STRING_objectType: "tileMap",
        STRING_layerName: promptResults.LayerName,
        editorSettings: {
            BOOLEAN_visible: true,
            BOOLEAN_soloVisibility: false
        },
        ARRAY_useTileSetsWithIdentifyer: useTileSetsWithIdentifyer,
        parallaxSpeed: {
            FLOAT_x: 1.0,
            FLOAT_y: 1.0
        },
        mapSize: {
            INTEGER_width: recommendedWidth,
            INTEGER_height: recommendedHeight
        },
        map: []
    };
	
	var mapTileCount = objectToAdd.mapSize.INTEGER_width * objectToAdd.mapSize.INTEGER_height;
	var tileObject;

	for(i = 0; i < mapTileCount; i++){
		tileObject = {
			INTEGER_tileIndex : theTileSet.tileSetEditorSettings.INTEGER_airTile,
			INTEGER_tileSetIndex : 0,
			STRING_textString: "",
			STRING_tag: ""
		};
		objectToAdd.map.push(tileObject);
	}
	var addToArray = _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers;
	if(_ace.levelOrganizer.currentlySelected.length > 1){
		selectedLayerIndex = _ace.levelOrganizer.currentlySelected[1] + 1;
		addToArray.splice(selectedLayerIndex,0,objectToAdd);
	} else {
		addToArray.push(objectToAdd);
		selectedLayerIndex = addToArray.length - 1;
	}
	_ace.levelOrganizer.currentlySelected = [selectedLevelIndex, selectedLayerIndex];
	_ace.levelOrganizer.updateAllFromCurrentlySelected();
}

_ace.levelOrganizer.addLevelButton = function(){
	_ace.prompt({
		"Level Name (String)" : "Level ",
		"Pixels Wide (Int)" : 640, 
	 	"Pixels Heigh (Int)" : 320,
		"Tile Zoom Factor (Float)" : 1
 	}, 
	"_ace.levelOrganizer.addLevel()",
	"Add New Level To Project");
}

_ace.levelOrganizer.addLevel = function(){
	var promptResults = _ace.getPromptResults();
	var objectToAdd = {
	    STRING_objectType: "level",
	    STRING_levelName: promptResults.LevelName,
	    STRING_textString: "",
		levelPixelSize : {
	        INTEGER_width: promptResults.PixelsWide,
	        INTEGER_height: promptResults.PixelsHeigh
		},
		FLOAT_tileZoomFactor: promptResults.TileZoomFactor,
	    arrayOfLayers: []
	};
	var selectedLevelIndex;
	var addToArray = _ace.currentProject.arrayOfLevels;
	if(_ace.levelOrganizer.currentlySelected.length > 0){
		selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0] + 1;
		addToArray.splice(selectedLevelIndex,0,objectToAdd);
	} else {
		addToArray.push(objectToAdd);
		selectedLevelIndex = addToArray.length - 1;
	}
	_ace.levelOrganizer.currentlySelected = [selectedLevelIndex];
	_ace.levelOrganizer.updateAllFromCurrentlySelected();
}

_ace.levelOrganizer.deleteSelected = function(){
	var selectedArray = null;
	var deletedItem = null;
	var selectedLevelIndex;
	var layerToDeleteIndex;
	switch(_ace.levelOrganizer.currentlySelected.length){
		case 1: 
			selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
			selectedArray = _ace.currentProject.arrayOfLevels;
			if(_ace.currentProject.arrayOfLevels.length==1){
				_ace.prompt({}, "","Can't delete level. At least one level is needed.");	
				return;
			}
			deletedItem = selectedArray.splice(selectedLevelIndex,1)[0];
			_ace.levelOrganizer.currentlySelected = [];
		break; 
		case 2: 
			selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
			layerToDeleteIndex = _ace.levelOrganizer.currentlySelected[1];
			selectedArray = _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers;
			deletedItem = selectedArray.splice(layerToDeleteIndex,1)[0];
			if((_ace.levelOrganizer.currentlySelected[1]-1 < 0) == false){
				_ace.levelOrganizer.currentlySelected = [_ace.levelOrganizer.currentlySelected[0], _ace.levelOrganizer.currentlySelected[1]-1];
			} else {
				_ace.levelOrganizer.currentlySelected = [_ace.levelOrganizer.currentlySelected[0]];
			}
			
		break;
	}
	_ace.levelOrganizer.updateAllFromCurrentlySelected();
}

_ace.levelOrganizer.duplicateSelected = function(){
	var selectedArray = null;
	var duplicateItem = null;
	var selectedLevelIndex;
	var selectedLayerIndex;
	switch(_ace.levelOrganizer.currentlySelected.length){
		case 1: 
			selectedArray = _ace.currentProject.arrayOfLevels;
			selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];

			duplicateItem = _ace.currentProject.arrayOfLevels[selectedLevelIndex];
			duplicateItem = jQuery.extend(true, {}, duplicateItem);
			
			selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0] + 1;
			selectedArray.splice(selectedLevelIndex,0,duplicateItem);
			
			_ace.levelOrganizer.currentlySelected = [selectedLevelIndex];
		break; 
		case 2: 
			
			selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
			selectedLayerIndex = _ace.levelOrganizer.currentlySelected[1];
			
			selectedArray = _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers;

			duplicateItem = _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers[selectedLayerIndex];
			duplicateItem = jQuery.extend(true, {}, duplicateItem);
		
			selectedLayerIndex = _ace.levelOrganizer.currentlySelected[1] + 1;
			selectedArray.splice(selectedLayerIndex,0,duplicateItem);
		
			_ace.levelOrganizer.currentlySelected = [selectedLevelIndex, selectedLayerIndex];
		break;
	}
	_ace.levelOrganizer.updateAllFromCurrentlySelected();
}

_ace.levelOrganizer.makeLayersFoldable = function(){
	$(function() {
	    $('li.Level').each(function(i) {
	        var sub_ul = $(this).children().remove();
	        $(this).wrapInner('<a/>').find('a').click(function() {
	            sub_ul.toggle("blind", {}, 200);
	        });
	        $(this).append(sub_ul);
	    });
	    $('ul ul').hide();
	});
}

_ace.levelOrganizer.makeLevelsClickable = function(){
	$( ".Level" ).click(function(event) {
		_ace.promptCancel();
		event.stopPropagation();
		_ace.levelOrganizer.clickedLevel(this);
	});
}

_ace.levelOrganizer.makeLayersClickable = function(){
	$( ".Layer" ).click(function(event) {
		_ace.promptCancel();
		event.stopPropagation();
		_ace.levelOrganizer.clickedLayer(this);
	});
}

_ace.levelOrganizer.updateAllFromCurrentlySelected = function(levelElement){
	_ace.levelOrganizer.Draw();
	_ace.mainView.drawOutputCanvases();
	_ace.preferenceInspector.drawCurrentObject();
	var levelElement;
	var layerElement;
	switch(_ace.levelOrganizer.currentlySelected.length){
		case 0 :
		break; 
		case 1 :
			levelElement = $("#LevelsContiner").children().get(_ace.levelOrganizer.currentlySelected[0]);
			$(levelElement).addClass('SelectedLevel');
		break; 
		case 2 :
			levelElement = $("#LevelsContiner").children().get(_ace.levelOrganizer.currentlySelected[0]);
			layerElement = $(levelElement).find(".LayerList").children().get(_ace.levelOrganizer.currentlySelected[1]);
			$(layerElement).addClass( "SelectedLayer" );
		break; 
	}
}

_ace.levelOrganizer.clickedLevel = function(levelElement){
	$(".SettingsButton").removeClass( "SelectedSetting" );
	$(".Layer").removeClass( "SelectedLayer" );
	$(".Level").removeClass( "SelectedLevel" );
	$(levelElement).addClass( "SelectedLevel" );
	var levelIndex = $(levelElement).index();
	_ace.levelOrganizer.currentlySelected = [levelIndex];
	_ace.levelOrganizer.updateSelectedTileSetAndTile();
	_ace.preferenceInspector.drawCurrentObject();
	_ace.mainView.drawOutputCanvases();
	_ace.levelOrganizer.updateSelectedTileSetAndTile();
}

_ace.levelOrganizer.clickedLayer = function(layerElement){
	$(".SettingsButton").removeClass( "SelectedSetting" );
	$(".Layer").removeClass( "SelectedLayer" );
	$(".Level").removeClass( "SelectedLevel" );
	$(layerElement).addClass( "SelectedLayer" );
	var levelIndex = $(layerElement).parent().parent().index();
	_ace.levelOrganizer.currentlySelected = [levelIndex, $(layerElement).index()];
	_ace.levelOrganizer.updateSelectedTileSetAndTile();
	_ace.preferenceInspector.drawCurrentObject();
	_ace.mainView.drawOutputCanvases();
}

_ace.levelOrganizer.updateSelectedTileSetAndTile = function(){
	var selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
	var selectedLevelObject = _ace.currentProject.arrayOfLevels[selectedLevelIndex];
	var selectedLayerIndex = _ace.levelOrganizer.currentlySelected[1];
	var selectedLayerObject = selectedLevelObject.arrayOfLayers[selectedLayerIndex];
	if(selectedLayerObject){
		if(_ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet > selectedLayerObject.ARRAY_useTileSetsWithIdentifyer.length-1){
			_ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet = 0;
			_ace.currentProject.globalEditorSettings.INTEGER_selectedTile  = 0;
		}
	}
	
}


_ace.levelOrganizer.levelListPositionIndexOnStartDrag = null;
_ace.levelOrganizer.makeLevelsSortable = function(){
	$(function() {
		$( "#LevelsContiner" ).sortable({
   			start: function(event, ui) { _ace.levelOrganizer.sortableLevelsStart(event, ui); }, 
			stop: function(event, ui) { _ace.levelOrganizer.sortableLevelsStop(event, ui); },
			delay: 200
		});
		$( "#LevelsContiner" ).disableSelection();
	});
}

_ace.levelOrganizer.sortableLevelsStart = function (event, ui) {
	_ace.levelOrganizer.levelListPositionIndexOnStartDrag =  $(ui.item).index();
}

_ace.levelOrganizer.sortableLevelsStop = function (event, ui) {
	var listIndexWhenDropped = $(ui.item).index();
	_ace.levelOrganizer.moveLevelFromIndexToIndex(_ace.levelOrganizer.levelListPositionIndexOnStartDrag , listIndexWhenDropped);
}

_ace.levelOrganizer.moveLevelFromIndexToIndex = function(originalPosition, newPosition){
	var PageToMove = _ace.currentProject.arrayOfLevels.splice(originalPosition,1)[0];
	_ace.currentProject.arrayOfLevels.splice(newPosition,0,PageToMove);
	_ace.levelOrganizer.update();
}

_ace.levelOrganizer.layerContainerIdOnStartDrag = null;
_ace.levelOrganizer.layerListPositionIndexOnStartDrag = null;
_ace.levelOrganizer.makeLayersSortable = function(){
	$(function() {
		$( ".LayerList" ).sortable({
			connectWith: '.LayerList',
   			start: function(event, ui) { _ace.levelOrganizer.sortableLayersStart(event, ui); }, 
			stop: function(event, ui) { _ace.levelOrganizer.sortableLayersStop(event, ui); },
			delay: 200
		});
		$( ".LayerList" ).disableSelection();
	});
}

_ace.levelOrganizer.sortableLayersStart = function (event, ui) {
	_ace.levelOrganizer.layerContainerIdOnStartDrag = $(ui.item).parent().attr('id');
	_ace.levelOrganizer.layerListPositionIndexOnStartDrag =  $(ui.item).index();
}

_ace.levelOrganizer.sortableLayersStop = function (event, ui) {
	var listIndexWhenDropped = $(ui.item).index();
	var droppedContainerId = $(ui.item).parent().attr('id');
	_ace.levelOrganizer.moveLayerFromIndexInArrayToIndexInArray(_ace.levelOrganizer.layerListPositionIndexOnStartDrag, _ace.levelOrganizer.layerContainerIdOnStartDrag, listIndexWhenDropped, droppedContainerId);
}

_ace.levelOrganizer.moveLayerFromIndexInArrayToIndexInArray = function(originalPosition, originalContainerId, newPosition, newContainerId){
	var originalArray = null;
	var originalLevelIndex = null;
	originalLevelIndex = parseInt(originalContainerId.replace("LevelLayerList", ""), 10);
	originalArray = _ace.currentProject.arrayOfLevels[originalLevelIndex].arrayOfLayers;
	var LayerToMove = originalArray.splice(originalPosition,1)[0];
	var newArray = null;
	var newLevelIndex = null;
	newLevelIndex = parseInt(newContainerId.replace("LevelLayerList", ""), 10);
	newArray = _ace.currentProject.arrayOfLevels[newLevelIndex].arrayOfLayers;
	_ace.levelOrganizer.currentlySelected = [newLevelIndex, newPosition];
	newArray.splice(newPosition,0,LayerToMove);
	_ace.levelOrganizer.update();
	_ace.mainView.drawOutputCanvases();
	_ace.preferenceInspector.drawCurrentObject();
}

