
/* 
	-----------------------------------------------------------------

	A Tile Map Editor 2
	By Ola Persson
	ola@kongotec.com
	www.kongotec.com
	
	Main Canvas Description: 
	Adds and controls the main canvas element, where levels are drawn.
	
	-----------------------------------------------------------------
*/

_ace.mainView = {};
_ace.mainViewElementId = "#MainView";
_ace.mainView.mouseState="unpressed";
_ace.mainView.mouseOverTileIndex = 0;

_ace.mainView.bindMouseEvents = function(){
	$("#CanvasMouseCatcher").bind('contextmenu', function(event){
		event.preventDefault();
	});
	$("#CanvasMouseCatcher").mousedown(function(mouseDownEvent) {
		switch(mouseDownEvent.which){
			case 3 :
				_ace.mainView.mouseState = "delete";
			break;
			default : 
				_ace.mainView.mouseState = "draw";
				if (mouseDownEvent.shiftKey) {
	                
	            }
	            else if (mouseDownEvent.ctrlKey) {
	                
	            }
	            else if (mouseDownEvent.altKey) {
	                _ace.mainView.mouseState = "sample";
	            }
			break;
		}
		mouseDownEvent.preventDefault();
		_ace.mainView.actionSwitch();
	});
	$("#CanvasMouseCatcher").mouseout(function() {
		_ace.mainView.mouseState = "unpressed";
	});
	$("#CanvasMouseCatcher").mouseup(function(mouseDownEvent) {
		_ace.mainView.mouseState = "unpressed";
	});
	$("#CanvasMouseCatcher").mousemove(function(moveEvent){
		_ace.mainView.mouseMove(moveEvent);
		_ace.mainView.actionSwitch();
		moveEvent.preventDefault();
	});
}

_ace.mainView.actionSwitch = function(){
	if(_ace.levelOrganizer.currentlySelected.constructor != Array){
		return;
	}
	if(_ace.levelOrganizer.currentlySelected.length < 2){
		return;
	}
	switch(_ace.mainView.mouseState){
		case "draw" : 
		_ace.mainView.drawTile();
		break;
		case "sample" : 
		_ace.mainView.sampleTile();
		break;
		case "delete" : 
		_ace.mainView.deleteTile();
		break;
	}
}

_ace.mainView.mouseMove = function(event){
	if(_ace.levelOrganizer.currentlySelected.constructor != Array){
		return;
	}
	if(_ace.levelOrganizer.currentlySelected.length < 2){
		return;
	}
	var selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
	var selectedLevelLayerIndex = _ace.levelOrganizer.currentlySelected[1];
	var tileSetZero;
	var currentLevel = _ace.currentProject.arrayOfLevels[selectedLevelIndex];
	var currentLayer = currentLevel.arrayOfLayers[selectedLevelLayerIndex];
	for(var ii = 0; ii < _ace.currentProject.tileSets.length; ii++){
		if(_ace.currentProject.tileSets[ii].STRING_tileSetIdentifyer == currentLayer.ARRAY_useTileSetsWithIdentifyer[0]){
			tileSetZero = _ace.currentProject.tileSets[ii];
			break;
		}
	}
	var targetOffsetPosition = $("#TileMapLayer"+selectedLevelLayerIndex).offset();
	var CurrentTileX = Math.floor((event.pageX - targetOffsetPosition.left) / (tileSetZero.tilePixelSize.INTEGER_width * currentLevel.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor));
	var CurrentTileY = Math.floor((event.pageY - targetOffsetPosition.top) / (tileSetZero.tilePixelSize.INTEGER_height * currentLevel.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor));
	if( CurrentTileX >= currentLayer.mapSize.INTEGER_width || 
		CurrentTileX < 0 ||
		CurrentTileY >= currentLayer.mapSize.INTEGER_height || 
		CurrentTileY < 0
	){
		_ace.mainView.mouseOverTileIndex = -1;
	} else {
		_ace.mainView.mouseOverTileIndex = CurrentTileX + CurrentTileY * currentLayer.mapSize.INTEGER_width;
	}
}

_ace.mainView.changeTile = function(tileObject){
	if(_ace.mainView.mouseOverTileIndex==-1){
		return;
	}
	var selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
	var selectedLevelLayerIndex = _ace.levelOrganizer.currentlySelected[1];
	_ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers[selectedLevelLayerIndex].map[_ace.mainView.mouseOverTileIndex] = tileObject;
	_ace.mainView.drawOutputCanvases();
}

_ace.mainView.drawTile = function(){
	var tileObject = {
		INTEGER_tileIndex : _ace.currentProject.globalEditorSettings.INTEGER_selectedTile,
		INTEGER_tileSetIndex : _ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet,
		STRING_textString: "",
		STRING_tag: ""
	};
	_ace.mainView.changeTile(tileObject);
}

_ace.mainView.deleteTile = function(){
	var currentTileSetIndex = _ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet; 
	var tileObject = {
		INTEGER_tileIndex : _ace.currentProject.tileSets[currentTileSetIndex].tileSetEditorSettings.INTEGER_airTile,
		INTEGER_tileSetIndex : currentTileSetIndex,
		STRING_textString: "",
		STRING_tag: ""
	};
	_ace.mainView.changeTile(tileObject);
}

_ace.mainView.sampleTile = function(){
	var selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
	var selectedLevelLayerIndex = _ace.levelOrganizer.currentlySelected[1];
	var selectedLayer = _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers[selectedLevelLayerIndex];
	var currentTile = selectedLayer.map[_ace.mainView.mouseOverTileIndex];
	_ace.currentProject.globalEditorSettings.INTEGER_selectedTile = currentTile.INTEGER_tileIndex;
	_ace.currentProject.globalEditorSettings.INTEGER_selectedTileSet = currentTile.INTEGER_tileSetIndex;
	_ace.preferenceInspector.tilePalette.updateAll();
}

_ace.createOutPutCanvasContainer = function(){
	var html = '';
	$("#MainView").html('<div id="OutPutCanvasContainer" class="OutPutCanvasContainer"></div><div id="ParallaxCropArea" class="ParallaxCropArea"><div id="CanvasMouseCatcher" class="MouseCatcher"></div></div>');
	_ace.mainView.bindMouseEvents();
	$( "#ParallaxCropArea" ).scroll(function() {
		_ace.mainView.positionOutputCanvases();
	});
};

_ace.mainView.positionOutputCanvases = function(){
	if(_ace.levelOrganizer.currentlySelected.constructor == Array){
		if(_ace.levelOrganizer.currentlySelected.length > 0){ // A Level Is Selected
			var selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
			var selectedLevelObject = _ace.currentProject.arrayOfLevels[selectedLevelIndex];
			var parallaxMultiplyer;
			var parallaxCropAreaPosition = {
				x : $("#ParallaxCropArea").scrollLeft(),
				y : $("#ParallaxCropArea").scrollTop()
			};
			if(_ace.currentProject.parallaxMode.BOOLEAN_parallaxModeOn){
				for(i = 0; i < selectedLevelObject.arrayOfLayers.length; i++){
					$("#TileMapLayer"+i).css({
						"left" : (-parallaxCropAreaPosition.x * selectedLevelObject.arrayOfLayers[i].parallaxSpeed.FLOAT_x) + "px",
						"top" : (-parallaxCropAreaPosition.y * selectedLevelObject.arrayOfLayers[i].parallaxSpeed.FLOAT_x) + "px"
					});
				}
			} else {
				for(i = 0; i < selectedLevelObject.arrayOfLayers.length; i++){
					$("#TileMapLayer"+i).css({
						"left" : -parallaxCropAreaPosition.x + "px",
						"top" : -parallaxCropAreaPosition.y + "px"
					});
				}
			}
		}
	}
}

_ace.mainView.drawOutputCanvases = function(){
	var parallaxCropAreaSize = {
		width : 0,
		height : 0
	};
	parallaxCropAreaSize.width = _ace.currentProject.parallaxMode.INTEGER_screenSizeWidth;
	parallaxCropAreaSize.height = _ace.currentProject.parallaxMode.INTEGER_screenSizeHeight;
	parallaxCropAreaSize.width *= _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor;
	parallaxCropAreaSize.height *= _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor;
	var mouseCatcherSize = {
		width: 0,
		height: 0
	};
	var selectedLevelIndex = _ace.levelOrganizer.currentlySelected[0];
	var selectedLevelObject = _ace.currentProject.arrayOfLevels[selectedLevelIndex];
	if(_ace.levelOrganizer.currentlySelected.constructor == Array){
		if(_ace.levelOrganizer.currentlySelected.length > 0){
			if(_ace.currentProject.parallaxMode.BOOLEAN_parallaxModeOn){
				mouseCatcherSize = {
					width: Math.max(selectedLevelObject.levelPixelSize.INTEGER_width * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor, parallaxCropAreaSize.width),
					height: Math.max(selectedLevelObject.levelPixelSize.INTEGER_height * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor, parallaxCropAreaSize.height)
				};
			} else {
				var currentTileSet;
				for(var i = 0; i < selectedLevelObject.arrayOfLayers.length; i++){
					for(var ii = 0; ii < _ace.currentProject.tileSets.length; ii++){
						if(_ace.currentProject.tileSets[ii].STRING_tileSetIdentifyer == selectedLevelObject.arrayOfLayers[i].ARRAY_useTileSetsWithIdentifyer[0]){
							currentTileSet = _ace.currentProject.tileSets[ii];
							break;
						}
					}
					mouseCatcherSize = {
						width: Math.max((selectedLevelObject.arrayOfLayers[i].mapSize.INTEGER_width * currentTileSet.tilePixelSize.INTEGER_width) * selectedLevelObject.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor, mouseCatcherSize.width),
						height: Math.max((selectedLevelObject.arrayOfLayers[i].mapSize.INTEGER_height * currentTileSet.tilePixelSize.INTEGER_height) * selectedLevelObject.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor, mouseCatcherSize.height)
					};
				}
			}
		}
	}
	if(_ace.currentProject.parallaxMode.BOOLEAN_parallaxModeOn){
		parallaxCropAreaSize.width += "px";
		parallaxCropAreaSize.height += "px";
	} else {
		parallaxCropAreaSize.width = "100%";
		parallaxCropAreaSize.height = "100%";
	}
	$("#ParallaxCropArea").css({
		"width" : parallaxCropAreaSize.width,
		"height" : parallaxCropAreaSize.height
	});
	$("#OutPutCanvasContainer").css({
		"width" : parallaxCropAreaSize.width,
		"height" : parallaxCropAreaSize.height
	});
	$("#CanvasMouseCatcher").css({
		"width" : mouseCatcherSize.width + "px",
		"height" : mouseCatcherSize.height + "px"
	});
	$("#OutPutCanvasContainer").html("");
	if(_ace.levelOrganizer.currentlySelected.constructor != Array){
		return;
	}
	if(_ace.levelOrganizer.currentlySelected.length == 0){
		return;
	}
	var html;
	var layerVisibleClass;
	var soloVisibilityExist = false;
	var currentLayer;
	var OutlineClass;
	var i;
	for(i = 0; i < _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers.length; i++){
		currentLayer = _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers[i];
		if(currentLayer.editorSettings.BOOLEAN_soloVisibility==true){
			soloVisibilityExist = true;
			break;
		}
	}
	for(i = 0; i < _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers.length; i++){
		currentLayer = _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers[i];
		layerVisibleClass = currentLayer.editorSettings.BOOLEAN_visible ? "" : "HiddenLayer";
		layerVisibleClass = soloVisibilityExist ? "HiddenLayer" : layerVisibleClass;
		layerVisibleClass += currentLayer.editorSettings.BOOLEAN_soloVisibility ? " SoloVisibilityLayer" : "";
		OutlineClass = _ace.currentProject.globalEditorSettings.BOOLEAN_outlineLayers ? "Outline" : "";
		html = '<canvas id="TileMapLayer'+i+'" class="TileMapLayer '+layerVisibleClass+' '+OutlineClass+'"></canvas>';
		$("#OutPutCanvasContainer").append(html);
		var currentCanvasElement = document.getElementById('TileMapLayer'+i);
		var canvasContext = currentCanvasElement.getContext('2d');
		var tileSetZero;
		for(var ii = 0; ii < _ace.currentProject.tileSets.length; ii++){
			if(_ace.currentProject.tileSets[ii].STRING_tileSetIdentifyer == currentLayer.ARRAY_useTileSetsWithIdentifyer[0]){
				tileSetZero = _ace.currentProject.tileSets[ii];
				break;
			}
		}
		currentCanvasElement.width = (currentLayer.mapSize.INTEGER_width * tileSetZero.tilePixelSize.INTEGER_width) * selectedLevelObject.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor;
		currentCanvasElement.height = (currentLayer.mapSize.INTEGER_height * tileSetZero.tilePixelSize.INTEGER_height) * selectedLevelObject.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor;
		var layerTileSets = [];
		var currentTilesetIdentifyer;
		var j;
		for(j = 0; j < currentLayer.ARRAY_useTileSetsWithIdentifyer.length; j++){
			currentTilesetIdentifyer = currentLayer.ARRAY_useTileSetsWithIdentifyer[j];
			for(jj = 0; jj < _ace.currentProject.tileSets.length; jj++){
				if(_ace.currentProject.tileSets[jj].STRING_tileSetIdentifyer == currentTilesetIdentifyer ){
					var tempObject = {
						tileSet : _ace.currentProject.tileSets[jj],
						HTMLIMAGE_img : null
					};
					layerTileSets.push(tempObject);
					break;
				}
			}
		}
		for(j = 0; j < layerTileSets.length; j++){
			for(var jj  = 0; jj < _ace.currentProject.resources.images.length; jj++){
				if(_ace.currentProject.resources.images[jj].STRING_imgIdentifyer == layerTileSets[j].tileSet.STRING_imgIdentifyer ){
					layerTileSets[j].HTMLIMAGE_img = _ace.currentProject.resources.images[jj].HTMLIMAGE_img;
					break;
				}
			}
		}
		var currentTileSetIndex;
		var currentTileSet;
		var currentTileImage;
		var currentTile;
		var sourceCutOriginX = 0;
		var sourceCutOriginY = 0;
		var sourceCutWidth = 16;
		var sourceCutHeight = 16;
		var targetX = 0;
		var targetY = 0;
		var targetPasteWidth = 16;
		var targetPasteHeight = 16;
		for(var tileToDrawIndex = 0; tileToDrawIndex < _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers[i].map.length; tileToDrawIndex++){
			currentTile = _ace.currentProject.arrayOfLevels[selectedLevelIndex].arrayOfLayers[i].map[tileToDrawIndex];
			currentTileSetIndex = currentTile.INTEGER_tileSetIndex;
			currentTileSet = layerTileSets[currentTileSetIndex].tileSet;
			tileSetZero = layerTileSets[0].tileSet;
			currentTileImage = layerTileSets[currentTileSetIndex].HTMLIMAGE_img;
			sourceCutOriginX = currentTile.INTEGER_tileIndex % currentTileSet.tileCount.INTEGER_tilesWide;
			sourceCutOriginX = sourceCutOriginX * (currentTileSet.tilePixelSize.INTEGER_width + currentTileSet.pixelSpaceBetweenTiles.INTEGER_x) + currentTileSet.pixelStartPosition.INTEGER_x;
			sourceCutOriginY = Math.floor(currentTile.INTEGER_tileIndex / currentTileSet.tileCount.INTEGER_tilesWide);
			sourceCutOriginY = sourceCutOriginY * (currentTileSet.tilePixelSize.INTEGER_height + currentTileSet.pixelSpaceBetweenTiles.INTEGER_y) + currentTileSet.pixelStartPosition.INTEGER_x;
			sourceCutWidth = currentTileSet.tilePixelSize.INTEGER_width * selectedLevelObject.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor;
			sourceCutHeight = currentTileSet.tilePixelSize.INTEGER_height * selectedLevelObject.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor;
			targetX = tileToDrawIndex % currentLayer.mapSize.INTEGER_width;
			targetX = targetX * (tileSetZero.tilePixelSize.INTEGER_width * selectedLevelObject.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor); 
			targetY = Math.floor(tileToDrawIndex / currentLayer.mapSize.INTEGER_width);
			targetY = targetY * (tileSetZero.tilePixelSize.INTEGER_height * selectedLevelObject.FLOAT_tileZoomFactor * _ace.currentProject.globalEditorSettings.FLOAT_applicationZoomFactor);
			targetPasteWidth = currentTileSet.tilePixelSize.INTEGER_width;
			targetPasteHeight = currentTileSet.tilePixelSize.INTEGER_height;
			canvasContext.imageSmoothingEnabled = false;
			
			if(_ace.currentProject.globalEditorSettings.BOOLEAN_disablePixelSmoothing){
				canvasContext.imageSmoothingEnabled = false;
				canvasContext.webkitImageSmoothingEnabled = false;
				canvasContext.mozImageSmoothingEnabled = false;
			} else {
				canvasContext.imageSmoothingEnabled = true;
				canvasContext.webkitImageSmoothingEnabled = true;
				canvasContext.mozImageSmoothingEnabled = true;
			}
			
			
			sourceCutOriginX = Math.floor(sourceCutOriginX);
			sourceCutOriginY = Math.floor(sourceCutOriginY);
			targetPasteWidth = Math.floor(targetPasteWidth);
			targetPasteHeight = Math.floor(targetPasteHeight);
			targetX = Math.floor(targetX);
			targetY = Math.floor(targetY);
			sourceCutWidth = Math.floor(sourceCutWidth);
			sourceCutHeight = Math.floor(sourceCutHeight);

			canvasContext.drawImage(
				currentTileImage,
				sourceCutOriginX,
				sourceCutOriginY,
				targetPasteWidth,
				targetPasteHeight,
				targetX,
				targetY,
				sourceCutWidth,
				sourceCutHeight
			);
		}
	}
	_ace.mainView.positionOutputCanvases();
};

